package com.yice.webadmin.app.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.github.pagehelper.Page;
import com.yice.common.core.base.dao.BaseDaoMapper;
import com.yice.common.core.base.service.BaseService;
import com.yice.common.core.object.MyRelationParam;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.sequence.wrapper.IdGeneratorWrapper;
import com.yice.webadmin.app.dao.ModelManageMapper;
import com.yice.webadmin.app.model.ModelDeploy;
import com.yice.webadmin.app.model.ModelManage;
import com.yice.webadmin.app.model.ModelTask;
import com.yice.webadmin.app.model.ModelVersion;
import com.yice.webadmin.app.service.ModelDeployService;
import com.yice.webadmin.app.service.ModelManageService;
import com.yice.webadmin.app.service.ModelTaskService;
import com.yice.webadmin.app.service.ModelVersionService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * 模型管理数据操作服务类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Slf4j
@Service("modelManageService")
public class ModelManageServiceImpl extends BaseService<ModelManage, Long> implements ModelManageService {

    @Autowired
    private ModelManageMapper modelManageMapper;
    @Autowired
    private ModelVersionService modelVersionService;
    @Autowired
    private ModelTaskService modelTaskService;
    @Autowired
    private ModelDeployService modelDeployService;
    @Autowired
    private IdGeneratorWrapper idGenerator;

    /**
     * 返回当前Service的主表Mapper对象。
     *
     * @return 主表Mapper对象。
     */
    @Override
    protected BaseDaoMapper<ModelManage> mapper() {
        return modelManageMapper;
    }

    /**
     * 保存新增对象。
     *
     * @param modelManage 新增对象。
     * @return 返回新增对象。
     */
    @Override
    public ModelManage saveNew(ModelManage modelManage) {
        modelManageMapper.insert(this.buildDefaultValue(modelManage));
        return modelManage;
    }

    /**
     * 利用数据库的insertList语法，批量插入对象列表。
     *
     * @param modelManageList 新增对象列表。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveNewBatch(List<ModelManage> modelManageList) {
        if (CollUtil.isNotEmpty(modelManageList)) {
            modelManageList.forEach(this::buildDefaultValue);
            modelManageMapper.insertList(modelManageList);
        }
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public ModelManage saveNewWithRelation(ModelManage modelManage, JSONObject relationData) {
        this.saveNew(modelManage);
        this.saveOrUpdateRelationData(modelManage, relationData);
        return modelManage;
    }

    /**
     * 更新数据对象。
     *
     * @param modelManage         更新的对象。
     * @param originalModelManage 原有数据对象。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean update(ModelManage modelManage, ModelManage originalModelManage) {
        MyModelUtil.fillCommonsForUpdate(modelManage, originalModelManage);
        // 这里重点提示，在执行主表数据更新之前，如果有哪些字段不支持修改操作，请用原有数据对象字段替换当前数据字段。
        UpdateWrapper<ModelManage> uw = this.createUpdateQueryForNullValue(modelManage, modelManage.getModelId());
        return modelManageMapper.update(modelManage, uw) == 1;
    }

    private void saveOrUpdateRelationData(ModelManage modelManage, JSONObject relationData) {
        List<ModelVersion> modelVersionList =
                relationData.getObject("modelVersionList", new TypeReference<List<ModelVersion>>() {
                });
        // 对于一对多更新，分为以下三步：
        // 1. 在关联从表中，删除掉与主表字段关联，但是又没有出现在本地更新中的数据。我们将这些数据视为需要删除的数据。
        // 2. 在本次更新数据列表中，如果从表的对象没有主键Id，我们视为新数据，可以批量插入。
        // 3. 在本次更新数据列表中，如果从表的对象存在主键Id，我们视为已有数据，逐条更新。
        if (modelVersionList != null) {
            modelVersionService.updateBatchByModelId(modelManage.getModelId(), modelVersionList);
        }
    }

    /**
     * 删除指定数据。
     *
     * @param modelId 主键Id。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean remove(Long modelId) {
        if (modelManageMapper.deleteById(modelId) == 0) {
            return false;
        }
        modelVersionService.removeByModelId(modelId);
        modelTaskService.removeByModelId(modelId);
        modelDeployService.removeByModelId(modelId);
        return true;
    }

    /**
     * 获取单表查询结果。由于没有关联数据查询，因此在仅仅获取单表数据的场景下，效率更高。
     * 如果需要同时获取关联数据，请移步(getModelManageListWithRelation)方法。
     *
     * @param filter  过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<ModelManage> getModelManageList(ModelManage filter, String orderBy) {
        return modelManageMapper.getModelManageList(filter, orderBy);
    }

    /**
     * 获取主表的查询结果，以及主表关联的字典数据和一对一从表数据，以及一对一从表的字典数据。
     * 该查询会涉及到一对一从表的关联过滤，或一对多从表的嵌套关联过滤，因此性能不如单表过滤。
     * 如果仅仅需要获取主表数据，请移步(getModelManageList)，以便获取更好的查询性能。
     *
     * @param filter             主表过滤对象。
     * @param modelVersionFilter 一对多从表过滤对象。
     * @param modelTaskFilter    一对多从表过滤对象。
     * @param modelDeployFilter  一对多从表过滤对象。
     * @param orderBy            排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<ModelManage> getModelManageListWithRelation(ModelManage filter, ModelVersion modelVersionFilter, ModelTask modelTaskFilter, ModelDeploy modelDeployFilter, String orderBy) {
        List<ModelManage> resultList =
                modelManageMapper.getModelManageListEx(filter, modelVersionFilter, modelTaskFilter, modelDeployFilter, orderBy);
        // 在缺省生成的代码中，如果查询结果resultList不是Page对象，说明没有分页，那么就很可能是数据导出接口调用了当前方法。
        // 为了避免一次性的大量数据关联，规避因此而造成的系统运行性能冲击，这里手动进行了分批次读取，开发者可按需修改该值。
        int batchSize = resultList instanceof Page ? 0 : 1000;
        Set<String> ignoreFields = new HashSet<>();
        ignoreFields.add("modelTaskList");
        ignoreFields.add("modelDeployList");
        this.buildRelationForDataList(resultList, MyRelationParam.full(), batchSize, ignoreFields);
        return resultList;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public ModelManage saveAndCreateVersion(ModelManage modelManage, ModelVersion modelVersion) {
        ModelManage reModelManage = this.saveNew(modelManage);
        modelVersion.setModelId(reModelManage.getModelId());
        if (modelVersion.getBusinessLabel() == null && modelManage.getBusinessLabel() != null) {
            modelVersion.setBusinessLabel(modelManage.getBusinessLabel());
        }
        this.modelVersionService.saveNew(modelVersion);
        return reModelManage;
    }

    @Override
    public ModelVersion saveAndCreateVersionV(ModelManage modelManage, ModelVersion modelVersion) {
        ModelManage reModelManage = this.saveNew(modelManage);
        modelVersion.setModelId(reModelManage.getModelId());
        if (modelVersion.getBusinessLabel() == null && modelManage.getBusinessLabel() != null) {
            modelVersion.setBusinessLabel(modelManage.getBusinessLabel());
        }
        return this.modelVersionService.saveNew(modelVersion);
    }

    private ModelManage buildDefaultValue(ModelManage modelManage) {
        if (modelManage.getModelId() == null) {
            modelManage.setModelId(idGenerator.nextLongId());
        }
        MyModelUtil.fillCommonsForInsert(modelManage);
        return modelManage;
    }
}
